"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Signature = void 0;
const sdk_base_1 = require("@wormhole-foundation/sdk-base");
const layout_items_1 = require("./layout-items");
/** Signature represents the secp256k1 signature of a Guardian */
class Signature {
    r;
    s;
    v;
    constructor(r, s, v) {
        this.r = r;
        this.s = s;
        this.v = v;
    }
    encode() {
        return (0, sdk_base_1.serializeLayout)(layout_items_1.signatureItem, this);
    }
    static decode(data) {
        return (0, sdk_base_1.deserializeLayout)(layout_items_1.signatureItem, data);
    }
}
exports.Signature = Signature;
//# sourceMappingURL=signature.js.map