import { customizableBytes, } from "@wormhole-foundation/sdk-base";
import { universalAddressItem, chainItem, sequenceItem } from "../layout-items";
export const normalizedAmountLayout = [
    { name: "decimals", binary: "uint", size: 1 },
    { name: "amount", binary: "uint", size: 8 },
];
const prefixItem = (prefix) => ({ name: "prefix", binary: "bytes", custom: Uint8Array.from(prefix), omit: true });
export const nativeTokenTransferLayout = [
    prefixItem([0x99, 0x4E, 0x54, 0x54]),
    { name: "normalizedAmount", binary: "bytes", layout: normalizedAmountLayout },
    { name: "sourceToken", ...universalAddressItem },
    { name: "recipientAddress", ...universalAddressItem },
    { name: "recipientChain", ...chainItem() },
];
export const endpointMessageLayout = (prefix, customPayload) => [
    prefixItem(prefix),
    { name: "sourceManager", ...universalAddressItem },
    customizableBytes({ name: "managerPayload", lengthSize: 2 }, customPayload),
];
export const managerMessageLayout = (customPayload) => [
    { name: "sequence", ...sequenceItem },
    { name: "sender", ...universalAddressItem },
    customizableBytes({ name: "payload", lengthSize: 2 }, customPayload),
];
export const wormholeEndpointMessage = (customPayload) => endpointMessageLayout([0x99, 0x45, 0xFF, 0x10], customPayload);
//# sourceMappingURL=ntt.js.map